This announces the latest version of WSGopher, 1.1.  You'll find the
self extracting archive file 'wsg-11.exe' on dewey.tis.inel.gov in
pub/wsgopher.  Also, you will probably find it on boombox.micro.umn.edu
in pub/gopher/Windows, and sunsite.unc.edu in
pub/micro/pc-stuff/ms-windows/winsock/apps. 

-- Please note:

    WSGopher is copyrighted software.  You may freely use any and all of
    the files in the WSGopher distribution, and you may freely
    distribute the file wsg-11.exe.  You cannot remove or alter the
    copyright notice.  Also, you may not distribute for profit the
    WSGopher executable or the file wsg-11.exe without permission from
    EG&G Idaho, Inc.  If you wish to do this, or if you wish to obtain a
    non-exclusive source license, please contact Steve Borror, email
    swb@inel.gov, phone (208) 526-3883, or mail me at gopher@tis.inel.gov.

The file wsg-11.exe is a self extracting archive.  Please consult the
section below entitled "Installation".

If you try to run wsg-11 from the Program Manager, you will probably
get errors, and it certainly won't work.

-- Changes from versions 1.0/1.01

* Addition of Cancel and Cancel All buttons/menu options.  These
buttons cancel network activity for the current window or all windows,
respectively.  You will be asked whether you want to save the data you
have already accumulated, if indeed you did receive anything.

* Home Gopher is now more robust.  First, if you have two Home Gopher
servers configured, WSGopher (again) picks one at random.  This was
broken in version 1.0 but worked before that.

Second, if one Home Gopher fails, and you have two configured, WSGopher
will automatically try the "other one".  If both Home Gophers fail,
then you will be presented with a dialog box explaining what happened,
and then the Home Gopher setup.

Several individuals pointed these problems out, including Rob Peterson
and Andy Berkvam.

* The network layer is more robust.  For one thing, if you cannot create
a socket, you will get a more reasonable error message unless you are
indeed out of resources.  (A "socket" is the piece that clients and
servers talk to each other through; if you can't make one, then you are
really going nowhere.)  Thanks to Stephen Trier for pointing this out. 

In general, error reporting is improved.

* Longer ask forms should work better.

* Text documents should download and display more quickly; the display
is also improved.  Sometimes there was a "ghost line" at the bottom.  I
am hoping that some lines that weren't displayed will now be.  The temp
files that WSGopher used to create for large text documents are no
longer used.  I have tested the new logic with files up to 32,305 lines,
about 1.8 MB; the download seemed to have a consistent speed throughout.
Thanks to Mark Edwards and Kyle Parrish for helping me to find largish
files. 

* When you are selecting text in the text window, the line containing
the selected text no longer goes up and to the left one pixel.

* The text window scrollbar now works like you would expect; operations
that go to the bottom now position the scrollbar at the bottom, etc.
Thanks to the countless people who mentioned this :-)

* The results of phone searches now can be quite long, on the order of
64K lines if needed.  I have been unable to find a phone search that
returned more than 700 entries, or roughly 4K lines.

* When you fetch something from the Bookmark Editor, the editor can
either stay up (as it has in the past), or will be minimized or close
automatically.  See the Options dialog to control this behavior.  Many,
many people suggested this to me.

* The Information window now has buttons for copying, closing and help.
The way copying works is this:  if you have any text selected in the
window, then that text is copied.  Otherwise, all the text in the
window is copied.

* The phone book no longer auto-selects the "name" field.  This is more
appropriate for the newer CSO servers, which either don't have a
default field or have one other than "name".  There is no means by
which a CSO client, such as WSGopher, can determine which field is
default.  Thanks to Steve Fram and Peter Wood for their correspondence.

* I _believe_ I have worked around the "empty directory" problem.  All
the empty directories I have found since that time have indeed been
empty.  You should now be able to safely use "application/gopher+-menu"
at the top of your Preferred Views list, like I do :-)

Yes, thousands of people pointed out this problem to me, but no one
suggested a solution.

* If you select an ask form, and for some reason the form does not have
any ask data, it will attempt to get it from the Gopher server.  If it
fails the form will be closed, after an explanatory message.
Otherwise, it's business as usual.

* Copying exceptionally large amounts of data to the clipboard now
works.  For instance, you can now copy "All the Gopher Servers in the
World".  Various folks have pointed this out to me, but it was really
hard to track down because you had to copy (it turns out) more than a
`segment' worth; who made up this segmentation stuff, anyway?

* WSGopher now is much more proactive in detecting the end of the data
stream _without_ waiting for WinSock to send a network event to that
effect.  This means that many Gopher+ images should be viewed
immediately when they are 100% complete; also directories, text files
and extended bookmark information should be complete much more quickly.
This should be most helpful to users of Trumpet 1 beta 10. 

This still won't help some Gopher+ downloads, or any Gopher0 binary
downloads.  If the server doesn't tell WSGopher exactly how large the
item is, or if it's not delimited the way a directory or text file
should be, then WSGopher has now way of knowing. 

* Added a "Fetch" command to the Bookmark menu; this displays a dialog
that contains two scrolling lists, one for the current categories
(assuming you have any) and one for the bookmarks in the category you
select (first shows "default category" if you have one).  Select a
category, then select a bookmark.  To fetch, either double click the
bookmark or click the OK button.  It's a lot faster than using the
Bookmark Editor.  This dialog is resizable; the title list gets wider
but the category list stays the same.  It's a feature, not a bug :-)

* If you fetch an item in a directory, and along the way you select a
view for this item, WSGopher now "cleans up" the item so that when you
next fetch it you can select a view without being forced to use the
same view as before.

* Implemented Paul Lindner's advice WRT extended views and language
tags.  Thanks, Paul!

* Implemented a "reload" feature; for directory, text and phone
windows, you can use File/Reload or the F5 key to refresh the contents
of the window.  This only works when the transfer is complete.

* Fixed a long standing bug where, if for some reason you were
downloading a binary file into a text window, the window no longer
crashes just because it can't reasonably handle lines more than 32K
bytes long.  Just the same, you might still not see anything in the text
window.  The moral of the story is not to download binary files into a
text window!  If you do this, try File/Fetch Item As to use the same
bookmark with the Image type. 

* Implemented an intelligent "back track".  Any window that was created
via another window, that is something selected from a directory, or the
directory that results from a search, is capable of restoring its
parent if that parent still exists.  See the arrow that points up and
left in the Toolbar, or Window/Back track.  I have lost count of the
number of people who asked me for something like this; Andy Berkvam was
one of the more recent folks who I discussed it with.  Thanks to
everyone who brought it up, no exceptions.

* Along the same lines, when you fetch a bookmark, WSGopher now tries
to determine if you already have a window for that bookmark; if so
WSGopher restores the window rather than fetching again.  Note that in
many cases you can "reload" if needed.

Ask forms are the exception; you may have more than one instance of an
ask form.

* Added a setting to the Options dialog to accomodate users who do not
wish to use WSGopher as a multi windowed application; some folks are
just more comfortable with the single window approach, apparently.
Anyway, the setting is kept across sessions and enforced during the
session.

* Alert user Robert Fabian discovered that if you use certain defective
free True Type fonts with WSGopher, that it can crash with a "divide by
zero" error ... WSGopher now protects itself from such bogus fonts.

* Michael Haseltine (and probably others) pointed out that, when you are
saving a text window to disk, WSGopher doesn't check to see if the file
already exists.  It does now. 

* Added a new menu entry and toolbar button for saving the bookmark for
a directory.  It is only available when the current window is a
directory.

* Fixed a bug in the ask form that would cause one or more Note's at
the end of a form to not be displayed.  Gail Bird, our project Gopher
admin, found this.  Thanks, Gail!  Also added page up, page down, home
and end to form windows; I wish I could figure out how to add tabs and
back tabs so it would act like a real dialog.

* Thanks to Robert Fabian, I found and fixed a bug where occasionally a
text file would think it is "finished" only partway through.

* You can now pass a Gopher URL on the command line; this will override
the Home Gopher server.  Scott Barker of UNC provided the impetus.

* If you try to print or print/preview and the file is not completely
downloaded, you will now get a dialog box to the effect that you can
print, but it will be incomplete.  Milton Turner suggested this.

* You can now specify a selector with your Home Gopher server(s).  Mark
Johnson prompted me on this one.

* The Bookmark information window is now resizable.

* You can now specify an alternate directory for configuration files,
including WSGopher.INI.  There are two methods, the environment
variable WSG_CONFIG and the command line argument -I followed by the
directory name.  The command line argument takes precedence.

Let's say your configuration files, including the INI, the CNF files
and the help file are stored in F:\gopher.  You could call WSGopher
like so:

    wsgopher.exe -IF:\gopher

or you could set the environment variable like so:

    set WSG_CONFIG F:\gopher

Many thanks to Alex Reijnierse for his patience in helping me work
through this, and to Carl Karcher.

* Fixed problems with ask blocks with no associated views; this is
pretty unusual ... but hopefully now WSGopher will work with the
Stanford Portfolio system.

* Text search _within_ WSGopher now supports the Boolean operators AND,
OR, NOT and ADJ.  These are simple Boolean searches, no paranthenes,
and only two arguments.  For instance you can search for 

    Dave OR David

but not (Dave OR David) AND Brooks

The operator separates the operands; for instance 

    Dave Brooks AND WSGopher

matches material containing both the strings "Dave Brooks" and
"WSGopher".  Blanks count, except between the operator and the operands. 

The search is still line oriented.  When a match is found in a text
window, the operands are selected as well as the material inbetween.  As
before, search is supported in directories, text windows and phone
search results. 

A text string without one of the Boolean operators is used in a plain
search, as before.

Carla Cavianai, the TIS training coordinator, gets the credit for this
idea.  I think it is way cool.

-- Installation

First, be sure to exit WSGopher if it is running on your system.  Bad
things happen when you overwrite a running program.

Generally speaking, you will execute the file "wsg-11.exe" and unpack
everything in it.  Please note the following:

* If you have existing bookmarks from versions of WSGopher _prior to_
1.0 that you want to keep:

    First, rename your WSGOPHER.INI file to something else, maybe
    WSGOPHER.OLD.  Let's assume it is in your "wsgopher" directory. 

    Execute the file "wsg-11.exe".  Unpack everything in the
    distribution. 

    Using your favorite DOS editor, copy the "Bookmarks" section from
    WSGOPHER.OLD to the new WSGOPHER.INI.  Here is how you do that:

    1) Find the text "[Bookmarks]" in WSGOPHER.OLD.  Copy all this text,
    through the first blank line.  It could be a very large chunk of
    text, depending on how many bookmarks you saved. 

    2) Open the file WSGOPHER.INI, go to the bottom of the file, and
    insert the text you copied from WSGOPHER.OLD.  Make sure there is a
    blank line before "[Bookmarks]". 

    3) Close WSGOPHER.INI.  Run WSGopher 1.1.  When WSGopher sees
    bookmarks in the 'old' format it will create a category called
    "Default", translate all your old bookmarks into the new format, put
    them in the "Default" category, and delete the old bookmarks. 

* If you don't care about keeping your old bookmarks:

Just overwrite your old WSGOPHER.INI file with the new one in the
distribution.  Are you *sure* you want to do this?

* Other things you need to do to after installing WSGopher:

See the Help Topic "Configuring WSGopher" for a list of suggestions.

-- Vendor Info

Known to work with:
*  SuperTCP (DLL and VxD beta)
*  Distinct (Lan and PPP).
*  PC/TCP; be sure to use version 1.10 or later of the DLL, NOT version
   1.1
*  Trumpet, specifically 1.0a, beta #6, and beta #14.  Since beta #14
apparently has other problems, if you need bootp you are advised to
stick wtih beta #6.  WSGopher does NOT work with beta #10, #11 or other
betas before 14.
*  Windows for Workgroups and the "release" 32 bit TCP/IP

It's been reported to me that the following vendor stacks work:

*  Netmanage 3.12 and 4.0; some users have difficulty with 3.11 and
previous.  I have one report that a version of Netmanage 4.0 GPFs, but
apparently at least one patch file (c4004.exe) resolves that.
*  Lanera Windows Sockets API 1.1 for TCPOpen, Version 1.2.3
*  Persoft
*  Wollongong, PATHWAY RUNTIME version 2.0
*  Beame and Whiteside
*  Winner
*  PC-NFS version 5.1; apparently this works better than 5.0 (I make no
claims here, just passing on what is reported to me).  Apparently one
site where you can find patches is ftp.sunet.su:/pub/pc/pc-nfs
*  Novell Lan Workplace 4.1; in the previous release of WSGopher I
passed on third party information about patches to upgrade to version
4.1 of LWP.  On the machine sjf-lwp.novell.com in lwp4dos/winsock, I
noticed the files lwp189.txt and lwp189.exe.  Apparently these update
LWP from 4.1 to 4.2.  Please contact your vendor for more information.

** Windows NT does NOT work for various reasons.  I hope to make a native
32 bit version of WSGopher soon.

-- Important notes:

*  Occasionally I hear from users who are trying to run WSGopher with
the WSGOPHER.INI file with the "read only" attribute, or perhaps in a
read-only directory.  This is absolutely impossible; it will not work.

*  The files "extviews.cnf" and "language.cnf" have been added to the
WSGopher distribution.  They need to be writable, and they should be
placed wherever you decide to put WSGOPHER.INI.  That can be in the
same directory you've installed WSGopher, in your Windows directory, in
the directory where you execute WSGopher (if differnt), or somewhere on
your DOS path.

*  WSGopher does NOT support firewalls; I had hoped to support SOCKS in
this version but it will have to wait.  If you have a proprietary
firewall, feel free to send me the specs for having client applications
work with it.

-- If you have any questions, please email gopher@tis.inel.gov.

-- To report problems:

1)  Include the WSGopher version #; it is at the top of the main
    window, in the title bar.
2)  Include the manufacturer and version information for your WinSock
    stack.
3)  If you are having trouble with a specific site, please include a
    bookmark.
4)  If you are unable to resolve hostnames or connect, please consult
    your vendor for the latest version, and/or ask your network support
    folks for help first.

-- One more thing ...

I really appreciate the support of the beta testers and other folks who
have used the software in environments I don't have access to, provided
feedback on features, reported the occasional bug and suggested
improvements I never would have thought of; I am very gratified by the
level of interest in this software and the caliber of people using it.
If any of you are ever in Idaho Falls, Idaho (USA) be sure to look me up.

And, thanks again to Boyd Fjeldsted!  

Dave Brooks
